## mrpt 2.5.1+ds

=== CMakeLists.txt ===
﻿# ----------------------------------------------------------------------------
# Root CMake file for the MRPT libraries and applications
#
#  Run with "cmake ." at the root directory to build the makefiles for
#   the MRPT C++ library, the samples, and the applications. Some scripts
#   for generating the documentation, etc. are also updated.
#
#  For compiling instructions for all compilers and platforms, see
#   https://docs.mrpt.org/reference/latest/compiling.html
#
#  2007-2021, Jose Luis Blanco <jlblanco@ual.es>
# ----------------------------------------------------------------------------

if (POLICY CMP0048)
  # cmake warns if loaded from a min-3.x-required parent dir:
  cmake_policy(SET CMP0048 NEW)
endif()

# Tell CMake we'll use both C & C++ for use in its tests/flags.
project(MRPT LANGUAGES C CXX)

# -------------------------
#        Setup CMake
# -------------------------
if (WIN32)
	cmake_minimum_required(VERSION 3.4) # required for CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS
else()
	cmake_minimum_required(VERSION 3.3)
endif()

# CheckIncludeFile: Yes, we will set "CMAKE_REQUIRED_LIBRARIES".
if (POLICY CMP0075)
	cmake_policy(SET CMP0075 NEW)
endif()

if ((NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/nanogui/include")
    OR (NOT IS_DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}/3rdparty/rplidar_sdk/sdk/sdk")
   )
  message(FATAL_ERROR "git submodules missing! "
    "You probably did not clone the project with --recursive. It is possible to recover "
    "by calling:\n  git submodule update --init --recursive\n")
endif()

# Display timing information for each compiler instance on screen
option(CMAKE_TIMING_VERBOSE "Enable the display of timing information for each compiler instance." OFF)
mark_as_advanced(CMAKE_TIMING_VERBOSE)

# Enable verbose timing display?
if(CMAKE_TIMING_VERBOSE AND UNIX)
  set_property(GLOBAL PROPERTY RULE_MESSAGES OFF)
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_CURRENT_SOURCE_DIR}/cmakemodules/custom_output.sh")
endif(CMAKE_TIMING_VERBOSE AND UNIX)

# Detect wordsize:
if(CMAKE_SIZEOF_VOID_P EQUAL 8)  # Size in bytes!
	set(CMAKE_MRPT_WORD_SIZE 64)
else()
	set(CMAKE_MRPT_WORD_SIZE 32)
endif()

include(cmakemodules/script_version_number.cmake REQUIRED)	#  Loads MRPT version number

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmakemodules") # Directory for CMake scripts

# -------------------------
#            CodeCov
# -------------------------
enable_testing()
find_package(codecov)
# -------------------------

option(MRPT_ALLOW_LGPLV3 "Allows MRPT to use LGPLV3 code (mrpt-vision-lgpl)" "OFF")

option(MRPT_EXCEPTIONS_WITH_CALL_STACK "Report callstack upon exceptions" "ON")
set(MRPT_EXCEPTIONS_CALL_STACK_MAX_DEPTH "50" CACHE STRING "Maximum number of stack levels to show upon exceptions.")
mark_as_advanced(MRPT_EXCEPTIONS_CALL_STACK_MAX_DEPTH)

# The root directory for all MRPT libraries/modules:
set(MRPT_LIBS_ROOT "${CMAKE_CURRENT_SOURCE_DIR}/libs" CACHE INTERNAL "")  # This emulates global vars

# ----- Useful macros ------
include(cmakemodules/UtilsMacros.cmake REQUIRED)
include(cmakemodules/DebugMacros.cmake REQUIRED)
include(cmakemodules/FilterFileLists.cmake REQUIRED)
include(cmakemodules/DeclareMRPTLib.cmake REQUIRED)
include(cmakemodules/DeclareMEXLib.cmake REQUIRED)
include(cmakemodules/DeclareAppDependencies.cmake REQUIRED)
include(cmakemodules/script_detect_unix_arch.cmake REQUIRED) # Detect machine architecture, on UNIX
# --------------------------

# Avoid the need for DLL export/import macros in Windows:
if (WIN32)
	set(CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS  ON)
endif()

# ------------------------------------------
# We want libraries to be named "libXXX"
#  in all compilers, and "-dbg" for debug
# ------------------------------------------
if(MSVC)
	set(MRPT_LIB_PREFIX "lib")  # Libs are: "libXXX"
endif()
set(CMAKE_DEBUG_POSTFIX  "-dbg")

# In case of Makefiles if the user does not setup CMAKE_BUILD_TYPE, assume it's Release:
if (${CMAKE_GENERATOR} MATCHES ".*Makefiles")
    if("${CMAKE_BUILD_TYPE}" STREQUAL "")
        set(CMAKE_BUILD_TYPE Release)
    endif()
endif()

include(cmakemodules/script_select_app_to_build.cmake REQUIRED)		# Build (or not) some apps:

# ----------------------------------------------------------------------------
# 		CHECK FOR SYSTEM LIBRARIES, OPTIONS, ETC..
# ----------------------------------------------------------------------------

# Build static or dynamic libs?
# ===================================================
# Default: dynamic libraries (except if building to JavaScript code)
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Emscripten")
	set(_def_value OFF)
else()
	set(_def_value ON)
endif()
set(BUILD_SHARED_LIBS ${_def_value} CACHE BOOL "Build shared libraries (.dll/.so) instead of static ones (.lib/.a)")
unset(_def_value)

if(BUILD_SHARED_LIBS)
	set(CMAKE_MRPT_BUILD_SHARED_LIB "#define MRPT_BUILT_AS_DLL")
	set(CMAKE_MRPT_BUILD_SHARED_LIB_ONOFF 1)
else()
	set(CMAKE_MRPT_BUILD_SHARED_LIB "/* #define MRPT_BUILT_AS_DLL */")
	set(CMAKE_MRPT_BUILD_SHARED_LIB_ONOFF 0)
endif()

# Only for emscripten: build executables as .html demo pages:
# =============================================================
if ("${CMAKE_SYSTEM_NAME}" STREQUAL "Emscripten")
	set(CMAKE_EXECUTABLE_SUFFIX ".html")
endif()

# Only for Unix: use pkg-config to find libraries
# ===================================================
include(FindPkgConfig OPTIONAL)

# Group projects in "folders"
set_property(GLOBAL PROPERTY USE_FOLDERS ON)
set_property(GLOBAL PROPERTY PREDEFINED_TARGETS_FOLDER "CMakeTargets")

# Build the RoboPeak Lidar library?
set(DEFAULT_BUILD_ROBOPEAK_LIDAR ON) # Default: Yes
if ((${CMAKE_MRPT_KERNEL} MATCHES "GNU") # It doesnt build in hurd
    OR APPLE # and macos
    OR ("$ENV{DEB_TARGET_ARCH_CPU}" STREQUAL "ppc64")   # fails: termios2
    OR ("$ENV{DEB_TARGET_ARCH_CPU}" STREQUAL "ppc64el") # fails: termios2
    OR ("$ENV{DEB_TARGET_ARCH_CPU}" STREQUAL "powerpc") # fails: termios2
    OR MINGW
    )
	set(DEFAULT_BUILD_ROBOPEAK_LIDAR OFF)
endif()
# Decl option:
set(MRPT_WITH_ROBOPEAK_LIDAR ${DEFAULT_BUILD_ROBOPEAK_LIDAR} CACHE BOOL "Build an embedded version of RoboPeak LIDAR SDK (interface to low-cost lidar)")
if(MRPT_WITH_ROBOPEAK_LIDAR)
	set(CMAKE_MRPT_HAS_ROBOPEAK_LIDAR 1)
else()
	set(CMAKE_MRPT_HAS_ROBOPEAK_LIDAR 0)
endif()

#-----------------------------------
#  Build with MRPT-MEX compatibility?
#-----------------------------------
set(MRPT_WITH_MATLAB_WRAPPER OFF CACHE BOOL "Build with compatibility options for MEX wrapper?.")

# GCC only:
# ===================================================
if(CMAKE_COMPILER_IS_GNUCXX)
	# Enable libstdc++ parallel mode?
	set(MRPT_ENABLE_LIBSTD_PARALLEL_MODE OFF CACHE BOOL "Enable parallel mode in libstdc++ (requires GCC 4.2.2+)")
endif()

# Enable precompiled headers:
# ===================================================
if (MSVC)
	set(default_use_precomp ON)
else()
	# JLBC 28th Dec 2017: It seems cotire does not work well with imported -I
	# directories via target_include_directories(... PUBLIC/INTERFACE ...)
	set(default_use_precomp OFF)
endif()
set(MRPT_ENABLE_PRECOMPILED_HDRS ${default_use_precomp} CACHE BOOL "Enable precompiled headers")
mark_as_advanced(MRPT_ENABLE_PRECOMPILED_HDRS)

# MRPT_TRY_START/END blocks
# ===================================================
set(MRPT_HAS_STACKED_EXCEPTIONS ON CACHE BOOL "Enable MRPT_TRY_START/END blocks (disable it for speed up).")

# ASSERT_ blocks
set(MRPT_HAS_ASSERT ON CACHE BOOL "Enable ASSERT_ statements (disable it for speed up).")

# "Classic" function & headers detection:
include(cmakemodules/script_detect_functions_headers.cmake REQUIRED)

# MSVC only:
# ===================================================
if(MSVC)
	# Enable Parallel compilation?
	set(COMPILE_IN_PARALLEL ON CACHE BOOL "Enable parallel compilation in Visual Studio")
endif()

# ----------------------------------------------------------------------------
#   Uninstall target, for "make uninstall"
# Must be invoked *before* other embedded projects so MRPT's target "uninstall" exists first
# ----------------------------------------------------------------------------
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/parse-files/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

add_custom_target(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

set_target_properties(uninstall PROPERTIES FOLDER "CMakeTargets")

# See docs for CMake FindThreads()
set(THREADS_PREFER_PTHREAD_FLAG ON)
find_package(Threads) # Defines imported target Threads::Threads

# ccache:
if(NOT MSVC AND NOT XCODE_VERSION)
    option(MRPT_BUILD_WITH_CCACHE "Use ccache compiler cache" ON)
    find_program(CCACHE_FOUND ccache)
	mark_as_advanced(CCACHE_FOUND)
    if(CCACHE_FOUND)
        if(MRPT_BUILD_WITH_CCACHE)
            set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ccache)
            set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK ccache)
        else()
            set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "")
            set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK "")
        endif()
    endif()
endif()

# ----------------------------------------------------------------------------
# Other sub-scripts:
# ----------------------------------------------------------------------------
include(cmakemodules/script_assimp.cmake REQUIRED)      # Check for system assimp lib (3D models)
include(cmakemodules/script_bfd.cmake REQUIRED)      # BFD library for debug symbols for stack backtraces
include(cmakemodules/script_clang_tidy.cmake REQUIRED)  # Clang tidy
include(cmakemodules/script_duo3d.cmake REQUIRED)       # Support for DUO3D Camera
include(cmakemodules/script_eigen.cmake REQUIRED)       # Eigen3
include(cmakemodules/script_ffmpeg.cmake REQUIRED)      # Check for ffmpeg C libraries: libavcodec, libavutil, libavformat, libswscale
include(cmakemodules/script_flycapture2.cmake REQUIRED) # Check for PointGreyResearch (PGR) FlyCapture2 library
include(cmakemodules/script_ftdi.cmake REQUIRED)        # Check for the FTDI headers (Linux only, in win32 we use built-in header & dynamic DLL load):
include(cmakemodules/script_gcc_clang_id.cmake REQUIRED) # Helper variables
include(cmakemodules/script_gl_glut.cmake REQUIRED)     # Check for the GL,GLUT libraries
include(cmakemodules/script_gridmap_options.cmake REQUIRED) # Gridmap options
include(cmakemodules/script_gtest.cmake REQUIRED)       # Unit testing lib
include(cmakemodules/script_inotify.cmake REQUIRED)     # Check for the sys/inotify headers (Linux only, in win32 we use the equivalent API for file system monitoring):
include(cmakemodules/script_isense.cmake REQUIRED)      # Support for INTERSENSE Sensors
include(cmakemodules/script_iwyu.cmake REQUIRED)        # Include-what-you-use
include(cmakemodules/script_jpeg.cmake REQUIRED)        # Check for jpeg
include(cmakemodules/script_jsoncpp.cmake REQUIRED)     # Check for jsoncpp
include(cmakemodules/script_kinect.cmake REQUIRED)      # Kinect support in a set of different ways
include(cmakemodules/script_libdc1394.cmake REQUIRED)   # Check for libdc1394-2
include(cmakemodules/script_libfyaml.cmake REQUIRED)    # Defines embedded version of libfyaml
include(cmakemodules/script_liblas.cmake REQUIRED)      # Check for the LAS LiDAR format library
include(cmakemodules/script_libtclap.cmake REQUIRED)    # Check for system libtclap
include(cmakemodules/script_matlab.cmake REQUIRED)      # Support for Matlab MEX functions generation
include(cmakemodules/script_mynteye.cmake REQUIRED)     # Support for MYNT EYE cameras
include(cmakemodules/script_nanogui.cmake REQUIRED)     # Check for nanogui
include(cmakemodules/script_nanoflann.cmake REQUIRED)   # Check for nanoflann
include(cmakemodules/script_national_instruments.cmake REQUIRED)  # NI C library
include(cmakemodules/script_nite2.cmake REQUIRED)       # Check for NITE2 library

=== samples/CMakeLists.txt ===
project(ALL_EXAMPLES)

add_custom_target(examples ALL)

set(MRPT_BUILD_EXAMPLES OFF CACHE BOOL "Build examples?")
if(MRPT_BUILD_EXAMPLES)
	set(CMAKE_MRPT_EXAMPLES_BASE_DIRECTORY ${CMAKE_CURRENT_LIST_DIR})

	# Generate examples_config.h
	configure_file(
    "${MRPT_SOURCE_DIR}/parse-files/examples_config.h.in"
    "${MRPT_CONFIG_FILE_INCLUDE_DIR}/mrpt/examples_config.h")

	# Generate CMakeLists.txt for each example:
	message(STATUS "Generating CMakefiles.txt for examples...")

	# ---------------------------------------------------------------
	#  MACRO for samples directories
	# ---------------------------------------------------------------
	macro(GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY)
		#TODO: Disable build if BUILD_mrpt_xxx is OFF

		# Convert CMAKE_EXAMPLE_DEPS -> CMAKE_EXAMPLE_DEPS_STRIP
		#          "mrpt::xxx mrpt::yyy" -> "xxx yyy"
		set(CMAKE_EXAMPLE_DEPS_STRIP "")
		foreach(DEP ${CMAKE_EXAMPLE_DEPS})
		    # Only for "mrpt::XXX" libs:
			if (DEP MATCHES "^mrpt::?:*(.*)")
			    string(REGEX REPLACE "mrpt::?:*(.*)" "\\1" STRIP_DEP ${DEP})
				list(APPEND CMAKE_EXAMPLE_DEPS_STRIP ${STRIP_DEP})
			endif()
		endforeach(DEP)

		foreach(CMAKE_MRPT_EXAMPLE_NAME ${LIST_EXAMPLES_IN_THIS_DIR})
			# Generate project file:
			configure_file(
			  ${MRPT_SOURCE_DIR}/samples/CMakeLists_template.txt.in
			  ${MRPT_SOURCE_DIR}/samples/${CMAKE_MRPT_EXAMPLE_NAME}/CMakeLists.txt
			  @ONLY)
			# And parse it:
			add_subdirectory(${CMAKE_MRPT_EXAMPLE_NAME})
		endforeach()
	endmacro()
	# ---------------------------------------------------------------
	#  END OF MACRO for samples directories
	# ---------------------------------------------------------------


	# === Depending on: core ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		core_exceptions_example
		core_backtrace_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::core)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: typemeta ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		typemeta_TTypeName
		typemeta_StaticString
		typemeta_TEnumType
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::typemeta)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: rtti ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		rtti_example1
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::rtti)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: containers, systems ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		containers_yaml_example
		containers_params_by_name
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::containers mrpt::system)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()


	# === Depending on: serialization, io ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		# ----
		serialization_json_example
		serialization_stl
		serialization_variant_example
		# ----
		io_pipes_example
		io_compress_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::serialization mrpt::io mrpt::poses)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: system ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		system_datetime_example
		system_directory_explorer_example
		system_file_system_watcher
		system_dirs_files_manipulation
		system_progress_bar
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::system mrpt::poses mrpt::io)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: system+math+gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		system_control_rate_timer_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::system mrpt::math mrpt::gui mrpt::tclap)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::math mrpt::random mrpt::gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		math_csparse_example
		math_kmeans_example
		math_matrix_example
		math_optimize_lm_example
		math_slerp_example
		math_spline_interpolation
		math_leastsquares_example
		math_ransac_plane3d_example
		math_ransac_plane3d_example2
		math_ransac_examples
		math_model_search_example
		math_polygon_split
		math_polygon_intersection
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::math mrpt::random mrpt::gui mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	set(LIST_EXAMPLES_IN_THIS_DIR
		math_polyhedron_intersection_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::math mrpt::random mrpt::gui mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::poses ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		poses_geometry_3D_example
		poses_pdfs_example
		poses_se3_lie_example
		poses_quaternions_example
		poses_sog_merge_example
		poses_unscented_transform_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::poses mrpt::io mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::comms ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		comms_http_client
		comms_nodelets_example
		comms_serial_port_example
		comms_socket_example
		comms_ftdi_usb_enumerate_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::comms mrpt::serialization mrpt::poses)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::gui, mrpt::img, mrpt::opengl, mrpt::maps ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		# -------
		opengl_objects_demo
		opengl_offscreen_render_example
		opengl_octree_render_huge_pointcloud
		opengl_texture_sizes_test
		opengl_custom_shaders_demo
		# -------
		img_basic_example
		img_convolution_fft
		img_fft_example
		img_gauss_filtering_example
		# -------
		gui_capture_render_to_img_example
		gui_display3D_example
		gui_display3D_custom_render
		gui_fbo_render_example
		gui_display_plots
		gui_nanogui_demo
		gui_text_fonts_example
		gui_gravity3d_example
		gui_windows_events
		gui_depth_camera_distortion
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::gui mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::gui, mrpt::hwdrivers ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		opengl_video_demo
		opengl_video_viewport_demo
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::gui mrpt::hwdrivers)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::gui, mrpt::maps ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		opengl_ray_trace_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::gui mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::random ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		random_examples
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::random mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: mrpt::bayes, mrpt::obs, mrpt::gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		bayes_tracking_example
		bayes_rejection_sampling_example
		bayes_resampling_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::bayes mrpt::obs mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: maps ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		# -----
		maps_gridmap_likelihood_characterization
		maps_gridmap_voronoi_example
	)
    set(CMAKE_EXAMPLE_DEPS mrpt::maps mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: slam ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		maps_gridmap_benchmark
		slam_icp_simple_example
		slam_icp3d_simple_example
		slam_range_only_localization_rej_sampling_example
	)
    set(CMAKE_EXAMPLE_DEPS mrpt::slam mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: topography ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		topography_gps_coords_example
		topography_coordinate_conversion_example
	)
    set(CMAKE_EXAMPLE_DEPS mrpt::topography)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: vision ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		vision_create_video_file_example
		vision_checkerboard_detectors
		vision_feature_extraction
		vision_keypoint_matching_example
		vision_multiple_checkerboards
		vision_stereo_calib_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::vision mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	if(MRPT_ALLOW_LGPLV3)
		# === Depending on: vision-lgpl ===
		set(LIST_EXAMPLES_IN_THIS_DIR
			vision_bundle_adj_example
			)
		set(CMAKE_EXAMPLE_DEPS mrpt::vision-lgpl mrpt::gui)
		GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()
	endif()

	# === Depending on: obs ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		obs_mox_model_rawlog
		# special utilities:
		rgbd_dataset2rawlog
		kitti_dataset2rawlog
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::obs)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: maps, gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		maps_laser_projection_in_images_example
		maps_gridmap3D_simple
		maps_observer_pattern_example
		maps_octomap_simple
		maps_gmrf_map_example
		maps_ransac_data_association
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::maps mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: graphs & gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		graphs_astar_example
		graphs_dijkstra_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::graphs mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: graphslam & gui ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		graphslam_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::graphslam mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: gui & hwdrivers ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		hwdrivers_camera_capture_dialog
		hwdrivers_capture_video_opencv
		hwdrivers_capture_video_dc1394
		hwdrivers_capture_video_ffmpeg
		hwdrivers_capture_video_flycapture2
		hwdrivers_capture_video_flycapture2_stereo
		hwdrivers_enumerate_cameras1394
		hwdrivers_gps_example
		hwdrivers_joystick_example
		hwdrivers_ntrip_client_example
		hwdrivers_phidget_proximity_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::hwdrivers mrpt::gui)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: maps & hwdrivers ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		hwdrivers_swissranger_example
		hwdrivers_sick_serial_example
		hwdrivers_sick_eth_example
		hwdrivers_hokuyo_example
		hwdrivers_robopeaklidar_example
		hwdrivers_kinect_to_2d_scan_example
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::hwdrivers mrpt::maps)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === Depending on: slam & hwdrivers ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		hwdrivers_kinect_online_offline_example
		hwdrivers_mynteye_icp
	)
    set(CMAKE_EXAMPLE_DEPS mrpt::slam mrpt::hwdrivers)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === HWDRIVERS & VISION ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		vision_capture_video_build_pyr
		vision_stereo_rectify
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::vision mrpt::hwdrivers)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === HWDRIVERS & DETECTORS ===
	set(LIST_EXAMPLES_IN_THIS_DIR
		detectors_face
		)
	set(CMAKE_EXAMPLE_DEPS mrpt::slam mrpt::hwdrivers mrpt::detectors)
	GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()

	# === OPENNI2 examples ===
	if (MRPT_HAS_OPENNI2)
		set(LIST_EXAMPLES_IN_THIS_DIR
			hwdrivers_openni2_driver_demo
			hwdrivers_openni2_2d_icp_slam
			)
		set(CMAKE_EXAMPLE_DEPS mrpt::hwdrivers mrpt::gui mrpt::opengl mrpt::maps)
		GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()
	endif(MRPT_HAS_OPENNI2)

	# === Navigation examples ===
	if(BUILD_mrpt-nav)
		set(LIST_EXAMPLES_IN_THIS_DIR
			nav_circ_robot_path_planning
			nav_rrt_planning_example
			)
		set(CMAKE_EXAMPLE_DEPS mrpt::nav mrpt::gui)
		GENERATE_CMAKE_FILES_SAMPLES_DIRECTORY()
	endif()

	message(STATUS "Done.")
endif()

=== debian/changelog ===
mrpt (1:2.5.1+ds-1) unstable; urgency=medium

  * New upstream version 2.5.1+ds
  * Add patch to fix FTBFS error on i386.

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Thu, 19 Aug 2022 22:47:00 +0200

=== debian/control ===
Source: mrpt
Section: science
Priority: optional
Maintainer: Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13),
	cmake,
	doxygen-latex,
	doxygen,
	freeglut3-dev,
	ghostscript,
	graphviz,
	libassimp-dev,
	libavcodec-dev, libavformat-dev, libavutil-dev, libswscale-dev,
	libcv-bridge-dev,
	libdc1394-dev [linux-any],
	libeigen3-dev,
	libfreenect-dev,
	libftdi1-dev,
	libgeometry-msgs-dev,
	libglfw3-dev,
	libglu1-mesa-dev,
	libicu-dev,
	libjpeg-dev,
	libjsoncpp-dev,
	libnanoflann-dev,
	libnav-msgs-dev,
	liboctomap-dev,
	libopencv-dev,
	libopenni2-dev,
	libpcap-dev,
	libqt5opengl5-dev,
	librosbag-storage-dev,
	libroscpp-dev,
	libsensor-msgs-dev,
	libsimpleini-dev,
	libstd-srvs-dev,
	libstereo-msgs-dev,
	libsuitesparse-dev,
	libtf2-dev,
	libtf2-msgs-dev,
	libtinyxml2-dev,
	libudev-dev [linux-any],
	libusb-1.0-0-dev [linux-any],
	libwxgtk3.0-gtk3-dev,
	libxrandr-dev,
	libxxf86vm-dev,
	qtbase5-dev,
	texlive, latexmk, texlive-latex-extra, texlive-science,
	zlib1g-dev,
	libgtest-dev,
	fonts-roboto-fontface,
	libfyaml-dev
Standards-Version: 4.6.1
Homepage: https://www.mrpt.org/
Vcs-Git: https://salsa.debian.org/robotics-team/mrpt.git
Vcs-Browser: https://salsa.debian.org/robotics-team/mrpt
Description: Mobile Robot Programming Toolkit
 The Mobile Robot Programming Toolkit (MRPT) is an extensive, cross-platform,
 and open source C++ library aimed to help robotics researchers to design and
 implement algorithms in the fields of Simultaneous Localization and Mapping
 (SLAM), computer vision, and motion planning (obstacle avoidance).

Package: mrpt-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: ${misc:Depends},
	libjs-jquery
Description: ${source:Synopsis} - examples
 ${source:Extended-Description}
 .
 Commented C++ examples for MRPT libraries.

Package: libmrpt-apps2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - apps library
 ${source:Extended-Description}
 .
 Library wrapping several MRPT front-end applications.
 This package provides the binary library file.

Package: libmrpt-apps-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-apps2.5 (= ${binary:Version}),
         libmrpt-slam-dev, libmrpt-gui-dev, libmrpt-tclap-dev
Description: ${source:Synopsis} - apps development package
 ${source:Extended-Description}
 .
 Library wrapping several MRPT front-end applications.
 This package provides headers and libraries for development.

Package: libmrpt-bayes2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - bayes library
 ${source:Extended-Description}
 .
 Particle filtering and Kalman filter (EKF) algorithms.
 This package provides the binary library file.

Package: libmrpt-bayes-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-bayes2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-math-dev, libmrpt-config-dev
Description: ${source:Synopsis} - bayes development package
 ${source:Extended-Description}
 .
 Particle filtering and Kalman filter (EKF) algorithms.
 This package provides headers and libraries for development.


Package: libmrpt-comms2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - comms library
 ${source:Extended-Description}
 .
 Communication utilities: serial port, sockets, nodelets.
 This package provides the binary library file.

Package: libmrpt-comms-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-comms2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-io-dev
Description: ${source:Synopsis} - comms development package
 ${source:Extended-Description}
 .
 Communication utilities: serial port, sockets, nodelets.
 This package provides headers and libraries for development.

Package: libmrpt-config2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - config library
 ${source:Extended-Description}
 .
 Configuration files utilities, providing an extension of the INI file format.
 This package provides the binary library file.

Package: libmrpt-config-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-config2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-core-dev,libmrpt-system-dev,libmrpt-expr-dev
Description: ${source:Synopsis} - config development package
 ${source:Extended-Description}
 .
 Configuration files utilities, providing an extension of the INI file format.
 This package provides headers and libraries for development.

Package: libmrpt-containers2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - containers library
 ${source:Extended-Description}
 .
 A C++17 YAML class, and many other generic C++ container classes.
 This package provides the binary library file.

Package: libmrpt-containers-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-containers2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-core-dev
Description: ${source:Synopsis} - containers development package
 ${source:Extended-Description}
 .
 A C++17 YAML class, and many other generic C++ container classes.
 This package provides headers and libraries for development.

Package: libmrpt-core2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - core library
 ${source:Extended-Description}
 .
 Core functionality for all MRPT libraries.
 This package provides the binary library file.

Package: libmrpt-core-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-core2.5 (= ${binary:Version}),
         libmrpt-common-dev
Description: ${source:Synopsis} - core development package
 ${source:Extended-Description}
 .
 Core functionality for all MRPT libraries.
 This package provides headers and libraries for development.

Package: libmrpt-detectors2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - detectors library
 ${source:Extended-Description}
 .
 Vision-based detector algorithms and wrappers.
 This package provides the binary library file.

Package: libmrpt-detectors-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-detectors2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-gui-dev,libmrpt-slam-dev
Description: ${source:Synopsis} - detectors development package
 ${source:Extended-Description}
 .
 Vision-based detector algorithms and wrappers.
 This package provides headers and libraries for development.

Package: libmrpt-expr2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - expr library
 ${source:Extended-Description}
 .
 A wrapper on the expr library for dynamic mathematical expression evaluation.
 This package provides the binary library file.

Package: libmrpt-expr-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-expr2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-core-dev
Description: ${source:Synopsis} - expr development package
 ${source:Extended-Description}
 .
 A wrapper on the expr library for dynamic mathematical expression evaluation.
 This package provides headers and libraries for development.

Package: libmrpt-graphs2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - graphs library
 ${source:Extended-Description}
 .
 Generic graph containers and algorithms (Dijkstra, visitors, etc.).
 This package provides the binary library file.

Package: libmrpt-graphs-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-graphs2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-opengl-dev,libmrpt-poses-dev
Description: ${source:Synopsis} - graphs development package
 ${source:Extended-Description}
 .
 Generic graph containers and algorithms (Dijkstra, visitors, etc.).
 This package provides headers and libraries for development.

Package: libmrpt-graphslam2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - graphslam library
 ${source:Extended-Description}
 .
 Graph-SLAM implementations for pose networks.
 This package provides the binary library file.

Package: libmrpt-graphslam-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-graphslam2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-gui-dev,libmrpt-slam-dev
Description: ${source:Synopsis} - graphslam development package
 ${source:Extended-Description}
 .
 Graph-SLAM implementations for pose networks.
 This package provides headers and libraries for development.

Package: libmrpt-gui2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - gui library
 ${source:Extended-Description}
 .
 GUI utilities for displaying 2D and 3D graphics.
 This package provides the binary library file.

Package: libmrpt-nanogui2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Built-Using: fonts-roboto-fontface (= ${fonts-roboto-fontface:version})
Description: ${source:Synopsis} - nanogui library
 ${source:Extended-Description}
 .
 Fork of the nanogui library for use into MRPT GUI classes.
 This package provides the binary library file.

Package: libmrpt-gui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-gui2.5 (= ${binary:Version}),
         libmrpt-common-dev, libmrpt-opengl-dev, libmrpt-nanogui-dev
Description: ${source:Synopsis} - gui development package
 ${source:Extended-Description}
 .
 GUI utilities for displaying 2D and 3D graphics.
 This package provides headers and libraries for development.

Package: libmrpt-nanogui-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-nanogui2.5 (= ${binary:Version}),
         libglfw3-dev
Description: ${source:Synopsis} - nanogui development package
 ${source:Extended-Description}
 .
 Fork of the nanogui library for use into MRPT GUI classes.
 This package provides headers and libraries for development.

Package: libmrpt-hmtslam2.5
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: ${source:Synopsis} - hmtslam library
 ${source:Extended-Description}
 .
 Hybrid Metric Topological (HMT) SLAM reference implementation.
 This package provides the binary library file.

Package: libmrpt-hmtslam-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Breaks: libmrpt-dev (<< 1:2)
Replaces: libmrpt-dev (<< 1:2)
Depends: ${misc:Depends},libmrpt-hmtslam2.5 (= ${binary:Version}),

## mrpt 2.5.3+ds

=== debian/changelog ===
mrpt (1:2.5.3+ds-1) unstable; urgency=medium

  * New upstream version 2.5.3+ds

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Tue, 06 Sep 2022 15:59:06 +0200

mrpt (1:2.5.2+ds-2) unstable; urgency=medium

  * Disable building embedded version of libfreenect
  * Remove d/patches (already integrated upstream)

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Tue, 30 Aug 2022 16:17:25 +0200

mrpt (1:2.5.2+ds-1) unstable; urgency=medium

  * Fix and enable builds with LTO optimizations (Closes: #1015550).
  * Remove libfreenect as build dependency.
  * New upstream version 2.5.2+ds

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Tue, 30 Aug 2022 09:45:27 +0200

=== debian/control ===
--- 
+++ 
@@ -15,7 +15,6 @@
 	libcv-bridge-dev,
 	libdc1394-dev [linux-any],
 	libeigen3-dev,
-	libfreenect-dev,
 	libftdi1-dev,
 	libgeometry-msgs-dev,
 	libglfw3-dev,
@@ -392,3 +391,4 @@
 Breaks: libmrpt-dev (<< 1:2)
 Replaces: libmrpt-dev (<< 1:2)
 Depends: ${misc:Depends},libmrpt-hmtslam2.5 (= ${binary:Version}),
+         libmrpt-common-dev, libmrpt-graphslam-dev

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Makefile for MRPT Debian package.

include /usr/share/dpkg/architecture.mk

# Required to avoid hardening-no-bindnow lintian message:
export DEB_BUILD_MAINT_OPTIONS = hardening=+all,optimize=+lto

# default: dont build expensive caller graphs with dot in the documentation pkg
export MRPT_genCALLERGRAPHS=NO

# For multiarch support:
DEB_HOST_ARCH ?= $(shell dpkg-architecture -qDEB_HOST_ARCH)
DEB_TARGET_MULTIARCH ?= $(shell dpkg-architecture -qDEB_TARGET_MULTIARCH)
#DEB_HOST_ARCH_OS ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)

# SSE options: Use automatic flags, do not enforce any special SSE* flags:
CMAKE_ARCH_FLAGS = -DMRPT_AUTODETECT_SIMD=OFF

# Unit tests can be run with target "test_legacy", or "test_gdb", which shows stack
# traces on failure:
MRPT_TEST_TARGET = test_legacy

# Debug info from the cmake scripts
export VERBOSE = 1

# Avoid running out of memory on mipsel,mips64el
ifneq (,$(findstring mips,$(DEB_HOST_ARCH)))
  export DEB_CXXFLAGS_MAINT_APPEND += -g1
endif

# Exact version, needed for the Built-Using field:
robotofontversion := $(shell dpkg-query -W -f '$${Version}' fonts-roboto-fontface)
mrptversion2digits := $(shell find debian -name "libmrpt-nanogui?.?.install" | sed 's/^.*[^0-9]\([0-9]*\.[0-9]*\)\..*$$/\1/')

CMAKE_FLAGS = \
	-DMRPT_ALLOW_LGPLV3=ON \
	-DMRPT_WITH_KINECT=OFF \
	$(CMAKE_ARCH_FLAGS)

%:
	dh $@ --buildsystem=cmake

# Forward the CMAKE_FLAGS flags above to cmake:
override_dh_auto_configure:
	dh_auto_configure -- $(CMAKE_FLAGS)

execute_before_dh_gencontrol:
	echo "Using $(robotofontversion) as fonts-roboto-fontface version for debian/libmrpt-nanogui$(mrptversion2digits).substvars"
	echo 'fonts-roboto-fontface:version=$(robotofontversion)' >> debian/libmrpt-nanogui$(mrptversion2digits).substvars

# For future use?
#override_dh_auto_build-arch:
#	dh_auto_build -O--buildsystem=cmake
#	# Python bindings:
#	dh_python3 --package=python3-mrpt

override_dh_auto_build-indep:
	# Build doc targets:
	# For both, arch dependent and independent targets, build "all".
	# This is to prevent future "make install" or "make test" to fail due to
	# not built targets.
	dh_auto_build -O--buildsystem=cmake -- \
		man_pages_all \
		documentation_psgz_guides \
		all

	# clean useless doxygen files:
	find $(CURDIR)/doc/ -name '*.md5' | xargs -I FIL rm FIL

override_dh_auto_test:
	dh_auto_build -O--buildsystem=cmake -- $(MRPT_TEST_TARGET)

## mrpt 2.5.5+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -19,14 +19,22 @@
 # Tell CMake we'll use both C & C++ for use in its tests/flags.
 project(MRPT LANGUAGES C CXX)
 
+if(NOT CMAKE_BUILD_TYPE AND NOT CMAKE_CONFIGURATION_TYPES)
+	set(default_build_type "Release")
+	message(STATUS "Setting build type to '${default_build_type}' as none was specified.")
+	set(CMAKE_BUILD_TYPE "${default_build_type}" CACHE
+		STRING "Choose the type of build." FORCE)
+	# Set the possible values of build type for cmake-gui
+	set_property(CACHE CMAKE_BUILD_TYPE PROPERTY STRINGS
+	"Debug" "Release" "MinSizeRel" "RelWithDebInfo" "Coverage")
+endif()
+
 # -------------------------
 #        Setup CMake
 # -------------------------
-if (WIN32)
-	cmake_minimum_required(VERSION 3.4) # required for CMAKE_WINDOWS_EXPORT_ALL_SYMBOLS
-else()
-	cmake_minimum_required(VERSION 3.3)
-endif()
+# Minimum version required for:
+# - target_compile_features() => 3.8.0
+cmake_minimum_required(VERSION 3.8)
 
 # CheckIncludeFile: Yes, we will set "CMAKE_REQUIRED_LIBRARIES".
 if (POLICY CMP0075)
@@ -268,8 +276,3 @@
 include(cmakemodules/script_liblas.cmake REQUIRED)      # Check for the LAS LiDAR format library
 include(cmakemodules/script_libtclap.cmake REQUIRED)    # Check for system libtclap
 include(cmakemodules/script_matlab.cmake REQUIRED)      # Support for Matlab MEX functions generation
-include(cmakemodules/script_mynteye.cmake REQUIRED)     # Support for MYNT EYE cameras
-include(cmakemodules/script_nanogui.cmake REQUIRED)     # Check for nanogui
-include(cmakemodules/script_nanoflann.cmake REQUIRED)   # Check for nanoflann
-include(cmakemodules/script_national_instruments.cmake REQUIRED)  # NI C library
-include(cmakemodules/script_nite2.cmake REQUIRED)       # Check for NITE2 library

=== debian/changelog ===
mrpt (1:2.5.5+ds-2) unstable; urgency=medium

  * Add patch to disable invalid unit tests on 32bit ARM architectures.

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Tue, 25 Oct 2022 01:00:39 +0200

mrpt (1:2.5.5+ds-1) unstable; urgency=medium

  * New upstream version 2.5.5+ds

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Wed, 19 Oct 2022 10:14:46 +0200

mrpt (1:2.5.4+ds-1) unstable; urgency=medium

  * fix uscan after recent github web change
  * New upstream version 2.5.4+ds
  * delete patches (not merged upstream)

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Sat, 24 Sep 2022 12:46:03 +0200

mrpt (1:2.5.3+ds-4) unstable; urgency=medium

  * Disable MRPT_TUNE_NATIVE (-mtune=native)
  * Patch from upstream: Do not explicitly add the -O3 flag.

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Fri, 16 Sep 2022 22:21:44 +0000

mrpt (1:2.5.3+ds-3) unstable; urgency=medium

  * Add patch to fix FTBFS in hppa build servers (Closes: #1019878).

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Thu, 15 Sep 2022 21:46:37 +0200

mrpt (1:2.5.3+ds-2) unstable; urgency=medium

  * Upgrade build-dep to wxWidgets 3.2 (Closes: #1019770).

 -- Jose Luis Blanco Claraco <joseluisblancoc@gmail.com>  Thu, 15 Sep 2022 02:57:48 +0200

=== debian/control ===
--- 
+++ 
@@ -41,7 +41,7 @@
 	libtinyxml2-dev,
 	libudev-dev [linux-any],
 	libusb-1.0-0-dev [linux-any],
-	libwxgtk3.0-gtk3-dev,
+	libwxgtk3.2-dev,
 	libxrandr-dev,
 	libxxf86vm-dev,
 	qtbase5-dev,
